import { AfterViewInit, Component, OnInit, ViewChild } from '@angular/core';
import { MatDialog } from '@angular/material/dialog';
import { MatPaginator } from '@angular/material/paginator';
import { MatSort } from '@angular/material/sort';
import { MatTableDataSource } from '@angular/material/table';
import { ConfirmOrderComponent } from './confirm-order/confirm-order.component';

const DATA_EXAMPLE: Array<any> = [
  {
    NUMERO_PEDIDO: '0000000001',
    DESPACHO: 'Despacho Tacubaya',
    DIRECCION: 'Tacubaya, 11870 Ciudad de México, CDMX',
    FECHA_REGISTRA: '2023-01-18 13:07:46',
    FECHA_MODIFICA: null,
    ESTADO: 'Entregado',
  },
  {
    NUMERO_PEDIDO: '0000000002',
    DESPACHO: 'Despacho Juanacatlán',
    DIRECCION: 'Pedro Antonio de Los Santos, San Miguel Chapultepec I Secc, 11850 Ciudad de México, CDMX',
    FECHA_REGISTRA: '2023-06-22 09:47:22',
    FECHA_MODIFICA: null,
    ESTADO: 'Devolución',
  },
  {
    NUMERO_PEDIDO: '0000000003',
    DESPACHO: 'Despacho Pino Suarez',
    DIRECCION: 'José María Pino Suárez, Centro, Cuauhtémoc, 06080 Ciudad de México, CDMX',
    FECHA_REGISTRA: '2023-03-20 10:21:12',
    FECHA_MODIFICA: null,
    ESTADO: 'Entregado',
  },
  {
    NUMERO_PEDIDO: '0000000004',
    DESPACHO: 'Despacho Tacubaya',
    DIRECCION: 'Tacubaya, 11870 Ciudad de México, CDMX',
    FECHA_REGISTRA: '2023-01-18 13:07:46',
    FECHA_MODIFICA: null,
    ESTADO: 'Entregado',
  },
  {
    NUMERO_PEDIDO: '0000000005',
    DESPACHO: 'Despacho Juanacatlán',
    DIRECCION: 'Pedro Antonio de Los Santos, San Miguel Chapultepec I Secc, 11850 Ciudad de México, CDMX',
    FECHA_REGISTRA: '2023-06-22 09:47:22',
    FECHA_MODIFICA: null,
    ESTADO: 'Devolución',
  },
];

@Component({
  selector: 'app-order-reception',
  templateUrl: './order-reception.component.html',
  styleUrls: ['./order-reception.component.css']
})
export class OrderReceptionComponent implements AfterViewInit, OnInit {
  // ---- Loading Data ----
  public isLoading: boolean;
  public isLoadingForm: boolean;

  // ---- SmartPage ----
  public btnSmall: boolean = false;

  @ViewChild(MatPaginator) paginator!: MatPaginator;
  @ViewChild(MatSort) sort!: MatSort;
  public displayedColumns: string[];
  public dataSource: MatTableDataSource<any>;
  public txtBuscador:string;

  constructor(
    public dialog: MatDialog,
  ) {
    this.displayedColumns = [
      'NUMERO_PEDIDO',
      'DESPACHO',
      'DIRECCION',
      'FECHA_REGISTRA',
      'ESTADO',
      'ACCIONES'
    ];
    this.dataSource = new MatTableDataSource(DATA_EXAMPLE);
    this.txtBuscador = '';
    this.isLoading = false;
    this.isLoadingForm = false;
    this.btnSmall = false;
  }

  ngOnInit(): void {
    this.onResize();
  }

  ngAfterViewInit(): void {
    this.dataSource.paginator = this.paginator;
    this.dataSource.sort = this.sort;
  }

  public openDialog(action: string, data: any = null) {
    if (action === 'CONF') {
      const dialogRef = this.dialog.open(ConfirmOrderComponent, {
        width: '400px',
        disableClose: true,
      });
    }
  }

  // Método de filtrado de datos
  public applyFilter(event: any, type: string):void {
    let filterValue:string;
    if (type == 'INP') {
      filterValue = (event.target as HTMLInputElement).value;
    }else{
      this.txtBuscador = event;
      filterValue = event;
    }
    this.dataSource.filter = filterValue.trim().toLowerCase();
    if (this.dataSource.paginator) {
      this.dataSource.paginator.firstPage();
    }
  }

  // Método para reajustar los botones según sus dimensiones
  public onResize():void {
    this.btnSmall = window.innerWidth <= 1405;
  }

  // Método para dar formato a las fechas y horas
  public formatDate(dateRegister:string, dateUpdate:string | null):string {
    let date:string = (dateUpdate === null) ? dateRegister : dateUpdate;
    let arrDateTime:Array<string> = date.split(' ');
    let arrDate:Array<string> = arrDateTime[0].split('-');
    return `${arrDate[2]}-${arrDate[1]}-${arrDate[0]} ${arrDateTime[1]}`;
  }
}

